Bug 1126711 - (CVE-2019-9020) VUL-1: CVE-2019-9020: php5,php7,php53: Invalid input to the function xmlrpc_decode() can lead to an invalid memory access (heap ou
(CVE-2019-9020)
VUL-1: CVE-2019-9020: php5,php7,php53: Invalid input to the function xmlrpc_d...
Status: RESOLVED FIXED
Classification: Novell Products
Product: SUSE Security Incidents
Classification: Novell Products
Component: Incidents
unspecified
Other Other
: P4 - Low : Minor
: ---
Assigned To: Security Team bot
Security Team bot
https://smash.suse.de/issue/225266/
maint:released:sle10-sp3:64227
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2019-02-25 06:37 UTC by Marcus Meissner
Modified: 2021-09-14 12:48 UTC (History)
1 user (show)

See Also:
Found By: Security Response Team
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Marcus Meissner 2019-02-25 06:37:08 UTC
CVE-2019-9020

An issue was discovered in PHP before 5.6.40, 7.x before 7.1.26, 7.2.x before
7.2.14, and 7.3.x before 7.3.1. Invalid input to the function xmlrpc_decode()
can lead to an invalid memory access (heap out of bounds read or read after
free). This is related to xml_elem_parse_buf in
ext/xmlrpc/libxmlrpc/xml_element.c.

References:
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2019-9020
https://bugs.php.net/bug.php?id=77242
https://bugs.php.net/bug.php?id=77249
Comment 1 Marcus Meissner 2019-02-25 06:42:04 UTC
QA REPRODUCER:

valgrind php -r '$a=xmlrpc_decode(base64_decode("PD94bWwgdmVyc2lvbmVuY29kaW5nPSJJU084ODU5NyKkpKSkpKSkpKSkpKSkpKSkpKSkpKSk"));'
Comment 2 Petr Gajdos 2019-03-07 09:08:46 UTC
BEFORE

$ USE_ZEND_ALLOC=0 valgrind -q php -r '$a=xmlrpc_decode(base64_decode("PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0iSVNPLTg4NTktNSI/PjxtPu+/vdTU1NTU1NTUaW54Png+77+91NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU79TU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NQ="));'
[..]
==14985== Invalid read of size 1
==14985==    at 0x4C25E22: strlen (in /usr/lib64/valgrind/amd64-linux/vgpreload_memcheck.so)
==14985==    by 0x512588: format_converter (snprintf.c:950)
==14985==    by 0x51307B: strx_printv (snprintf.c:1198)
==14985==    by 0x513153: ap_php_snprintf (snprintf.c:1243)
==14985==    by 0x6E24DB9: xml_elem_parse_buf (xml_element.c:726)
==14985==    by 0x6E26B2F: XMLRPC_REQUEST_FromXML (xmlrpc.c:809)
==14985==    by 0x6E1FB54: decode_request_worker (xmlrpc-epi-php.c:730)
==14985==    by 0x6E1FD68: zif_xmlrpc_decode (xmlrpc-epi-php.c:801)
==14985==    by 0x5907FC: zend_do_fcall_common_helper_SPEC (zend_vm_execute.h:200)
==14985==    by 0x579563: execute (zend_vm_execute.h:92)
==14985==    by 0x5479F5: zend_eval_string (zend_execute_API.c:1233)
==14985==    by 0x547B77: zend_eval_string_ex (zend_execute_API.c:1268)
==14985==  Address 0x6beb2b1 is not stack'd, malloc'd or (recently) free'd
[..]
$

PATCH

http://git.php.net/?p=php-src.git;a=commit;h=4fc0bceb7c39be206c73f69993e3936ef329f656

TW/php7, devel:languages:php:php56/php5 already fixed

AFTER

$ USE_ZEND_ALLOC=0 valgrind -q php -r '$a=xmlrpc_decode(base64_decode("PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0iSVNPLTg4NTktNSI/PjxtPu+/vdTU1NTU1NTUaW54Png+77+91NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU79TU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NQ="));'
$
Comment 3 Petr Gajdos 2019-03-07 09:10:10 UTC
Will submit for: 15/php7, 15/php72, 12/php7, 12/php5, 11sp3/php53, 11/php5 and 10sp3/php5
Comment 4 Petr Gajdos 2019-03-11 21:03:59 UTC
I believe all fixed.
Comment 6 Swamp Workflow Management 2019-03-13 17:37:05 UTC
An update workflow for this issue was started.
This issue was rated as low.
Please submit fixed packages until 2019-04-10.
When done, reassign the bug to security-team@suse.de.
https://swamp.suse.de/webswamp/wf/64226
Comment 10 Swamp Workflow Management 2019-04-05 19:19:25 UTC
SUSE-SU-2019:14013-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1126711,1126713,1126821,1126823,1127122,1128722,1128883,1128886,1128887,1128889,1128892
CVE References: CVE-2018-20783,CVE-2019-9020,CVE-2019-9021,CVE-2019-9023,CVE-2019-9024,CVE-2019-9637,CVE-2019-9638,CVE-2019-9639,CVE-2019-9640,CVE-2019-9641,CVE-2019-9675
Sources used:
SUSE Linux Enterprise Software Development Kit 11-SP4 (src):    php53-5.3.17-112.58.1
SUSE Linux Enterprise Server 11-SP4 (src):    php53-5.3.17-112.58.1
SUSE Linux Enterprise Point of Sale 11-SP3 (src):    php53-5.3.17-112.58.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    php53-5.3.17-112.58.1

*** NOTE: This information is not intended to be used for external
    communication, because this may only be a partial fix.
    If you have questions please reach out to maintenance coordination.
Comment 11 Swamp Workflow Management 2019-04-18 16:12:01 UTC
SUSE-SU-2019:0985-1: An update that fixes 6 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1126711,1126713,1126821,1126823,1127122,1128722
CVE References: CVE-2018-20783,CVE-2019-9020,CVE-2019-9021,CVE-2019-9023,CVE-2019-9024,CVE-2019-9641
Sources used:
SUSE Linux Enterprise Software Development Kit 12-SP4 (src):    php5-5.5.14-109.51.6
SUSE Linux Enterprise Software Development Kit 12-SP3 (src):    php5-5.5.14-109.51.6
SUSE Linux Enterprise Module for Web Scripting 12 (src):    php5-5.5.14-109.51.6

*** NOTE: This information is not intended to be used for external
    communication, because this may only be a partial fix.
    If you have questions please reach out to maintenance coordination.
Comment 12 Swamp Workflow Management 2019-04-23 15:07:02 UTC
openSUSE-SU-2019:1256-1: An update that fixes 6 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1126711,1126713,1126821,1126823,1127122,1128722
CVE References: CVE-2018-20783,CVE-2019-9020,CVE-2019-9021,CVE-2019-9023,CVE-2019-9024,CVE-2019-9641
Sources used:
openSUSE Leap 42.3 (src):    php5-5.5.14-115.1
Comment 14 Swamp Workflow Management 2019-04-29 13:09:18 UTC
openSUSE-SU-2019:1293-1: An update that solves 11 vulnerabilities and has one errata is now available.

Category: security (moderate)
Bug References: 1126711,1126713,1126821,1126823,1127122,1128722,1128883,1128886,1128887,1128889,1128892,1129032
CVE References: CVE-2018-20783,CVE-2019-9020,CVE-2019-9021,CVE-2019-9023,CVE-2019-9024,CVE-2019-9637,CVE-2019-9638,CVE-2019-9639,CVE-2019-9640,CVE-2019-9641,CVE-2019-9675
Sources used:
openSUSE Leap 42.3 (src):    php7-7.0.7-58.1
Comment 16 Swamp Workflow Management 2019-06-11 22:11:12 UTC
SUSE-SU-2019:1461-1: An update that solves 16 vulnerabilities and has two fixes is now available.

Category: security (moderate)
Bug References: 1118832,1119396,1126711,1126713,1126821,1126823,1126827,1127122,1128722,1128883,1128886,1128887,1128889,1128892,1129032,1132837,1132838,1134322
CVE References: CVE-2018-19935,CVE-2018-20783,CVE-2019-11034,CVE-2019-11035,CVE-2019-11036,CVE-2019-9020,CVE-2019-9021,CVE-2019-9022,CVE-2019-9023,CVE-2019-9024,CVE-2019-9637,CVE-2019-9638,CVE-2019-9639,CVE-2019-9640,CVE-2019-9641,CVE-2019-9675
Sources used:
SUSE Linux Enterprise Module for Web Scripting 15 (src):    php7-7.2.5-4.32.1
SUSE Linux Enterprise Module for Packagehub Subpackages 15 (src):    php7-7.2.5-4.32.1
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15 (src):    php7-7.2.5-4.32.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 17 Swamp Workflow Management 2019-06-18 16:37:38 UTC
openSUSE-SU-2019:1572-1: An update that solves 16 vulnerabilities and has two fixes is now available.

Category: security (moderate)
Bug References: 1118832,1119396,1126711,1126713,1126821,1126823,1126827,1127122,1128722,1128883,1128886,1128887,1128889,1128892,1129032,1132837,1132838,1134322
CVE References: CVE-2018-19935,CVE-2018-20783,CVE-2019-11034,CVE-2019-11035,CVE-2019-11036,CVE-2019-9020,CVE-2019-9021,CVE-2019-9022,CVE-2019-9023,CVE-2019-9024,CVE-2019-9637,CVE-2019-9638,CVE-2019-9639,CVE-2019-9640,CVE-2019-9641,CVE-2019-9675
Sources used:
openSUSE Leap 15.1 (src):    php7-7.2.5-lp151.6.3.1
Comment 18 Swamp Workflow Management 2019-06-18 16:42:51 UTC
openSUSE-SU-2019:1573-1: An update that solves 16 vulnerabilities and has two fixes is now available.

Category: security (moderate)
Bug References: 1118832,1119396,1126711,1126713,1126821,1126823,1126827,1127122,1128722,1128883,1128886,1128887,1128889,1128892,1129032,1132837,1132838,1134322
CVE References: CVE-2018-19935,CVE-2018-20783,CVE-2019-11034,CVE-2019-11035,CVE-2019-11036,CVE-2019-9020,CVE-2019-9021,CVE-2019-9022,CVE-2019-9023,CVE-2019-9024,CVE-2019-9637,CVE-2019-9638,CVE-2019-9639,CVE-2019-9640,CVE-2019-9641,CVE-2019-9675
Sources used:
openSUSE Leap 15.0 (src):    php7-7.2.5-lp150.2.19.1
Comment 19 Marcus Meissner 2019-07-16 06:06:37 UTC
done
Comment 22 OBSbugzilla Bot 2020-05-12 08:00:37 UTC
This is an autogenerated message for OBS integration:
This bug (1126711) was mentioned in
https://build.opensuse.org/request/show/802846 Factory / php7
Comment 23 OBSbugzilla Bot 2020-05-12 14:00:23 UTC
This is an autogenerated message for OBS integration:
This bug (1126711) was mentioned in
https://build.opensuse.org/request/show/802978 Factory / php7
Comment 24 OBSbugzilla Bot 2020-05-13 08:20:20 UTC
This is an autogenerated message for OBS integration:
This bug (1126711) was mentioned in
https://build.opensuse.org/request/show/804946 Factory / php7
Comment 26 OBSbugzilla Bot 2020-05-13 13:30:07 UTC
This is an autogenerated message for OBS integration:
This bug (1126711) was mentioned in
https://build.opensuse.org/request/show/805287 Factory / php7